PROGRAM HOPS;

USES    Crt,Graph;

VAR nbb:byte;
    xm,ym:integer;
    pilote,mode,i:integer;
    pions: array[1..9] of integer;
    distance: array[1..9] of real;
    sors,arcom,hop,voir:boolean;
    somme,test:integer;
    c:char;

FUNCTION SourisPresente:boolean;Assembler;
asm
  xor ax,ax
  int 33h
  cmp ax,0ffffh
  je @ok
  xor al,al
  jmp @endf
  @ok:
  mov al,1
  mov nbb,bl
  @endf:
end;
PROCEDURE SourisAffiche;Assembler;
asm
   mov ax,1
   int 33h
end;
PROCEDURE SourisCache;Assembler;
asm
   mov ax,2
   int 33h
end;
PROCEDURE SourisPointeurXY(x,y:integer);Assembler;
asm
   shl ax,1
   mov ax,4
   mov cx,x
   mov dx,y
   int 33h
end;
FUNCTION SourisGauche:boolean;Assembler;
asm
   mov ax,3
   int 33h
   and bx,01
   cmp bx,0
   je @nok
   mov al,1
   jmp @endf
   @nok:
   mov al,0
   @endf:
end;
FUNCTION SourisMilieu:boolean;Assembler;
asm
   mov ax,3
   int 33h
   and bx,04
   cmp bx,0
   je @nok
   mov al,1
   jmp @endf
   @nok:
   mov al,0
   @endf:
end;
FUNCTION SourisDroite:boolean;Assembler;
asm
    mov ax,3
    int 33h
    and bx,02
    cmp bx,0
    je @nok
    mov al,1
    jmp @endf
    @nok:
    mov al,0
    @endf:
end;
PROCEDURE SourisPosition;Assembler;
asm
   mov ax,3
   int 33h
   mov xm,cx
   mov ym,dx
   shr xm,1
end;

FUNCTION cui:boolean;
var
dd,xx,yy:real;
begin
cui:=false;
xx:=abs(600-xm*2);yy:=abs(458-ym);
dd:=sqrt(sqr(xx)+sqr(yy));
if dd<50 then cui:=true;
end;

FUNCTION cru:boolean;
var
du,xu,yu:real;
begin
cru:=false;
xu:=abs(50-xm*2);yu:=abs(458-ym);
du:=sqrt(sqr(xu)+sqr(yu));
if du<50 then cru:=true;
end;

FUNCTION Solus:boolean;
var
ds,xs,ys:real;
begin
solus:=false;
 xs:=abs(300-xm*2);ys:=abs(458-ym);
ds:=sqrt(sqr(xs)+sqr(ys));
if ds<50 then solus:=true;
end;

FUNCTION hophop:boolean;
var
ddd,xxx,yyy:real;
begin
hophop:=false;
xxx:=abs(320-xm*2);yyy:=abs(30-ym);
ddd:=sqrt(sqr(xxx)+sqr(yyy));
if ddd<40 then hophop:=true;
end;

FUNCTION Calcud:integer; {recherche du pion cliqu}
var
zz:integer;
xx,yy:real;
begin
calcud:=0;
For zz:=1 to 9 do
begin
xx:=abs(67*(zz-1)+50-(xm*2));yy:=abs(ym-220);
distance[zz] := sqrt( sqr(xx) + sqr(yy) );
if distance[zz]<30 then calcud:=zz;
end;
end;

PROCEDURE Initial;
begin
setfillstyle(6,9);setcolor(1);setlinestyle(0,0,1);
Bar3d(10,170,630,270,4,topon);
for i:=1 to 9 do
begin
circle(50+67*(i-1),220,31);
end;
setcolor(9);settextjustify(centertext,centertext);
settextstyle(3,0,2);outtextxy(320,30,'Hop!');
outtextxy(600,458,'Quit');outtextxy(50,458,'Restart');
outtextxy(320,458,'Soluce');
setcolor(0);setfillstyle(7,0);
pieslice(50+67*(5-1),220,0,360,30);
for i:=1 to 4 do begin
setcolor(4);setfillstyle(7,4);
pieslice(50+67*(i-1),220,0,360,30);
pions[i]:=4;
end;
pions[5]:=0;
for i:=6 to 9 do begin
setcolor(2);setfillstyle(7,2);
pieslice(50+67*(i-1),220,0,360,30);
pions[i]:=2;
end;
end;

PROCEDURE Explain; {clic sur Hop!}
begin
outtextxy(320,60,'Echangez les pions rouges et verts......');
outtextxy(320,90,'Les rouges se dplacent de gauche  droite,');
outtextxy(320,120,'les verts de droite  gauche.');
outtextxy(320,290,'Un pion peut se dplacer vers une case vide');
outtextxy(320,320,'ou sauter par-dessus un pion d''une autre couleur.');
outtextxy(320,350,'Bonne chance...');
outtextxy(320,380,'RALPH');
delay(12000);setcolor(0);
outtextxy(320,60,'Echangez les pions rouges et verts......');
outtextxy(320,90,'Les rouges se dplacent de gauche  droite,');
outtextxy(320,120,'les verts de droite  gauche.');
outtextxy(320,290,'Un pion peut se dplacer vers une case vide');
outtextxy(320,320,'ou sauter par-dessus un pion d''une autre couleur.');
outtextxy(320,350,'Bonne chance...');delay(500);
outtextxy(320,380,'RALPH');
end;

PROCEDURE Recolore;
var
appuiecon:boolean;
Begin
appuiecon:=true;
if ((pions[i]=4) and (i<>9))  then begin {clic sur pion rouge}
if pions[i+1]=0 then begin
setcolor(0);setfillstyle(7,0);
pieslice(50+67*(i-1),220,0,360,30);sound(1000);delay(10);nosound;
pions[i]:=0;appuiecon:=false;
setcolor(4);setfillstyle(7,4);
pieslice(50+67*i,220,0,360,30);
pions[i+1]:=4;end;
if ((pions[i+1]=2) and (i<>8)) then begin
if pions[i+2]=0 then begin
setcolor(0);setfillstyle(7,0);
pieslice(50+67*(i-1),220,0,360,30);sound(1000);delay(10);nosound;
pions[i]:=0;appuiecon:=false;
setcolor(4);setfillstyle(7,4);
pieslice(50+67*(i+1),220,0,360,30);
pions[i+2]:=4;
end;end;
end;
if ((pions[i]=2) and (i<>1))  then begin {clic sur pion vert}
if pions[i-1]=0 then begin
setcolor(0);setfillstyle(7,0);
pieslice(50+67*(i-1),220,0,360,30);sound(700);delay(10);nosound;
pions[i]:=0;appuiecon:=false;
setcolor(2);setfillstyle(7,2);
pieslice(50+67*(i-2),220,0,360,30);
pions[i-1]:=2;end;
if ((pions[i-1]=4) and (i<>2)) then begin
if pions[i-2]=0 then begin
setcolor(0);setfillstyle(7,0);
pieslice(50+67*(i-1),220,0,360,30);sound(700);delay(10);nosound;
pions[i]:=0;appuiecon:=false;
setcolor(2);setfillstyle(7,2);
pieslice(50+67*(i-3),220,0,360,30);
pions[i-2]:=2;
end;end;
end;
if appuiecon then begin sound(75);delay(300);nosound;end;
end;
PROCEDURE Soluce;
Const
cg:array[1..24] of integer=(4,6,7,5,3,2,4,6,8,9,7,5,3,1,2,4,6,8,7,5,3,4,6,5);
ch:array[1..24] of integer=(6,4,3,5,7,8,6,4,2,1,3,5,7,9,8,6,4,2,3,5,7,6,4,5);
Var
coups,haz:word;
Begin
haz:=random(2);
for coups:=1 to 24 do begin
if haz<>0 then begin
i:=ch[coups];recolore;delay(100);end
else begin i:=cg[coups];recolore;delay(100);end;
end;
setcolor(9);
outtextxy(320,100,'Et voil...');
outtextxy(320,360,'Comment? C''est trop rapide? ... Mais non!');
delay(4300);
setcolor(0);
outtextxy(320,100,'Et voil...');
outtextxy(320,360,'Comment? C''est trop rapide? ... Mais non!');
end;

PROCEDURE Victory;
Var
tes:integer;
begin
For tes:=1 to 9 do
begin
setcolor(2);setfillstyle(7,2);
pieslice(50+67*(tes-1),220,0,360,30);sound(tes*100);
delay(30);end;nosound;delay(300);
For tes:=1 to 9 do
begin
setcolor(tes);setfillstyle(7,tes);
pieslice(50+67*(tes-1),220,0,360,30);sound(tes*100);
delay(10);nosound;delay(150);end;
For tes:=1 to 9 do
begin
setcolor(9+tes);setfillstyle(7,9+tes);
pieslice(50+67*(10-tes-1),220,0,360,30);
sound((10-tes)*100);
delay(10);nosound;
delay(150);end;
For tes:=1 to 9 do
begin
setcolor(4);setfillstyle(7,4);
pieslice(50+67*(tes-1),220,0,360,30);sound(tes*100);
delay(30);end;nosound;delay(300);
clearviewport;settextstyle(7,0,10);
for tes:=1 to 145 do
begin
setcolor(14);
outtextxy(319,230,'BRAVO');delay(4);
setcolor(12);
outtextxy(319,230,'BRAVO');
setlinestyle(4,1,1);setcolor(1);
circle(320,240,2*tes);delay(4);
end;nosound;
clearviewport;
end;

BEGIN
pilote:=Detect;InitGraph(pilote,mode,'');
if GraphResult <> grOk then Halt(1);
if Sourispresente=False then begin closegraph;Halt(2);end;
Initial;
sors:=true;arcom:=true;
repeat
sourisaffiche;
              repeat
              sourisposition;
              arcom:=cru;
              sors:=cui;
              hop:=hophop;
              voir:=solus;
if keypressed then
begin
c:=readkey;
if c=#27 then begin closegraph;Halt(3);end;
end;
              if hop then begin
              setcolor(14);
              outtextxy(320,30,'Hop!');end
              else
              begin
              setcolor(9);
              outtextxy(320,30,'Hop!');end;
              if voir then begin
              setcolor(14);
              outtextxy(320,458,'Soluce');end
              else
              begin
              setcolor(9);
              outtextxy(320,458,'Soluce');end;
              if sors then begin
              setcolor(14);
              outtextxy(600,458,'Quit');end
              else
              begin
              setcolor(9);
              outtextxy(600,458,'Quit');end;
              if arcom then begin
              setcolor(14);
              outtextxy(50,458,'Restart');end
              else
              begin
              setcolor(9);
              outtextxy(50,458,'Restart');end;
              until sourisgauche;delay(100);
souriscache;
if arcom then begin sound(50);delay(55);nosound;Initial;end;
if voir then begin Initial;Soluce;Initial;end;
if hop then explain;
i:=calcud;
if calcud<>0 then recolore;
somme:=0;
for test:=1 to 4 do
begin
if pions[test]=2 then somme:=somme+1;
end;
if pions[5]=0 then somme:=somme+1;
if somme=5 then begin Victory;Initial;end;{c'est gagn}
until sors;
closegraph;
END.